// ReadAndLoadImageDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ReadAndLoadImage.h"
#include "ReadAndLoadImageDlg.h"
#include ".\readandloadimagedlg.h"
#include <atlimage.h> //CImage Obj
#include "afxdlgs.h" //File Concept

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


CString OpenImageFilePath = NULL;
bool OpenImageFileFlag = false, OfflineProcflag = false;

CRect oflrect, oflrectAlg;

BYTE OfflineImageData[768*256];
BYTE OfflineData[768][256];
int iIndex = 0;

int width;
int height;

CReadAndLoadImageDlg::CReadAndLoadImageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CReadAndLoadImageDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	oflrect.left = 25;
	oflrect.top = 50;
	oflrect.right = 800;
	oflrect.bottom = 320;

	oflrectAlg.left = 25;
	oflrectAlg.top  = 350;
	oflrectAlg.right = 800;
	oflrectAlg.bottom = 630;

}

void CReadAndLoadImageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CReadAndLoadImageDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_OPEN, OnBnClickedOpen)
	ON_BN_CLICKED(IDC_READ, OnBnClickedRead)
END_MESSAGE_MAP()


// CReadAndLoadImageDlg message handlers

BOOL CReadAndLoadImageDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//Initialize
	for (int y = 0; y < 768; y = y + 1)//Width
	{
		iIndex = y + (256 * 768) - 768;		
		for (int x = 0; x < 256 ; x = x + 1)//height
		{					
			OfflineData[y][x] = 0;
			iIndex = iIndex - 768;					
		}
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CReadAndLoadImageDlg::OnPaint() 
{
	CPaintDC dc(this);
	if(OpenImageFileFlag)
	{		
		//Load Image
		CDC *pDC;				
		pDC=GetDC();

		CImage ObjImage ;		
		ObjImage.Load(OpenImageFilePath) ; //Image Path	
		
		CBitmap pBitmap ;
		pBitmap.Attach(ObjImage.Detach());

		BITMAP bm;
		pBitmap.GetObject( sizeof(BITMAP), &bm );

		CDC         dcMem;
		dcMem.CreateCompatibleDC( pDC );

		CBitmap* pbmpOld = NULL;
		pbmpOld = dcMem.SelectObject( &pBitmap );

		pDC->BitBlt(25,50, bm.bmWidth, bm.bmHeight,&dcMem, 0,0, SRCCOPY );

		dcMem.SelectObject( pbmpOld );
		ReleaseDC( pDC );

		//Read Image - Get Bits from that image		
		CImage atlImage;
		atlImage.Load(OpenImageFilePath);

		void* pPixel = NULL;
		pPixel = atlImage.GetBits();

		int pitch = atlImage.GetPitch();

		int bytes = abs(pitch) * atlImage.GetHeight();

		const BYTE * src = NULL;
		src = (BYTE*)atlImage.GetBits();

		if(pitch < 0) src -= bytes;

		BYTE * pBitmapData = NULL;
		pBitmapData = new BYTE[bytes];

		memcpy(pBitmapData, src, bytes);
		//memmove(pBitmapData, src, bytes);
		
		width = atlImage.GetWidth();
		height = atlImage.GetHeight();
		
		for (int y = 0; y < width; y = y + 1)//1024  ImageHeight
		{
			iIndex = y + (width * height) - width;		
			for (int x = 0; x < height ; x = x + 1)//256  ImageWidth
			{	
				OfflineImageData[iIndex] = (byte)(*(pBitmapData + iIndex));
				OfflineData[y][x] = OfflineImageData[iIndex];
				iIndex = iIndex - width;					
			}
		}
		OpenImageFileFlag = false;

}//End OpenImageFileFlag


	//Read to Plot
		if(OfflineProcflag)//copy open dlg file data
		{			
			//Plot opendlg Image data
			for (int y = 0; y < width; y = y + 1)//1024  ImageHeight
			{
				for (int x = 0; x < height ; x = x + 1)//256  ImageWidth
				{		
					SetPixelV(dc,25+y,360+x,RGB(OfflineData[y][x],OfflineData[y][x],OfflineData[y][x])); //Default Screen Color				
				}
			}	
			OfflineProcflag = false;
		}						
		
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CReadAndLoadImageDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}
void CReadAndLoadImageDlg::OnBnClickedOpen()
{
	CFileException CFileEx;
	CStdioFile ReadFile;
   
   TCHAR szFilters[]= _T("Image Files (*.bmp)");

   CFileDialog fileDlg(TRUE, _T("bmp"), _T("*.bmp"),
      OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFilters);

   fileDlg.m_ofn.lpstrTitle = _T("Offline Images");
   // set open dialog box  default path C:\XRAY\SavedImg\RejectedImg\AcceptedImg
   fileDlg.m_pOFN->lpstrInitialDir=_T("C:\\XRAY\\SavedImg\\RejectedImg\\AcceptedImg\\");

   if(fileDlg.DoModal() == IDOK)
   {
      OpenImageFilePath = fileDlg.GetPathName();
	  OpenImageFileFlag = true;	 
	  InvalidateRect(&oflrect);
   }
}

void CReadAndLoadImageDlg::OnBnClickedRead()
{
	OfflineProcflag = true;
	InvalidateRect(&oflrectAlg);
}
